/***
 * Fractal ADL Task Framework Parser
 * Copyright (C) 2006-2007 STMicroelectronics
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * Contact: fractal@objectweb.org
 *
 * Author: Ali Erdem Ozcan
 */

package org.objectweb.fractal.task.core.composition.ast;

/**
 * An AST node interface to define a constant.
 */
public interface Constant extends Value {

  /** Enumeration of supported constant types. */
  public static enum ConstantTypeEnum {
    /** The name of the boolean constant type. */
    BOOLEAN,

    /** The name of the integer constant type. */
    INTEGER,

    /** The name of the string constant type. */
    STRING,

    /** The name of the <code>null</code> constant type. */
    NULL
  };

  String getValue();

  void setValue(String value);

  String getType();

  void setType(String type);
}
